
#include "avltree.h"

#include <iostream>
using namespace std;

#include <cstdlib> // for rand ()

class simple
{
public :

    int key;
    int payload;

    simple (int _key, int _payload)
        : key (_key), payload (_payload) { }

    simple (int _key) : key (_key) { }

    simple (const simple & rhs)
    {
        key = rhs.key;
        payload = rhs.payload;
    }

    bool operator== (const simple & rhs) const
    {
        return key == rhs.key;
    }

    bool operator< (const simple & rhs) const
    {
        return key >= rhs.key; 
    }

};

ostream & operator << (ostream & co, const simple & data)
{
    co << data.key << " is #" << data.payload;
    return co;
}

int main ()
{
    AVL::Tree<simple> tree;

    for (int i = 0; i < 100; i++)
    {
        simple v (rand () % 1000, i);
        const simple * vv = tree.find (v);
        if (vv != NULL)
        {
            cout << "already inserted " << *vv << endl;
        }
        else
        {
            cout << "insert " << v << endl;
            tree.insert (v);
            cout << tree << endl;
        }
    }

    cout << tree << endl;

    for (int j = 0; j < 1000; j++)
    {
        simple v (rand () % 1000);

        cout << "looking for " << v.key << " - ";
        const simple * vv = tree.find (v);
        if (vv != NULL)
        {
            cout << "found " << *vv << endl;
            cout << tree << endl;
        }
        else
        {
            cout << "not found" << endl;
        }
        tree.remove (v);
    }

    cout << tree << endl;

    return 0;
}

